/* ************************************************************************
 * Copyright (C) 2024 Advanced Micro Devices, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell cop-
 * ies of the Software, and to permit persons to whom the Software is furnished
 * to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IM-
 * PLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNE-
 * CTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * ************************************************************************ */

#include "../common_helpers.hpp"
#include "testing_rot_batched_ex.hpp"
#include "testing_rot_ex.hpp"
#include "testing_rot_strided_batched_ex.hpp"

// rot
#define INSTANTIATE_ROT_EX(T_)            \
    INSTANTIATE_TESTS(rot_ex, T_)         \
    INSTANTIATE_TESTS(rot_batched_ex, T_) \
    INSTANTIATE_TESTS(rot_strided_batched_ex, T_)

INSTANTIATE_ROT_EX(float)
INSTANTIATE_ROT_EX(double)
INSTANTIATE_ROT_EX(rocblas_float_complex)
INSTANTIATE_ROT_EX(rocblas_double_complex)

#define INSTANTIATE_ROT_EX_HPA(T_, U_, V_, W_)        \
    INSTANTIATE_TESTS(rot_ex, T_, U_, V_, W_)         \
    INSTANTIATE_TESTS(rot_batched_ex, T_, U_, V_, W_) \
    INSTANTIATE_TESTS(rot_strided_batched_ex, T_, U_, V_, W_)

INSTANTIATE_ROT_EX_HPA(rocblas_bfloat16, rocblas_bfloat16, rocblas_bfloat16, float)
INSTANTIATE_ROT_EX_HPA(rocblas_half, rocblas_half, rocblas_half, float)
INSTANTIATE_ROT_EX_HPA(rocblas_float_complex, rocblas_float_complex, float, rocblas_float_complex)
INSTANTIATE_ROT_EX_HPA(rocblas_double_complex,
                       rocblas_double_complex,
                       double,
                       rocblas_double_complex)
